#/*++
#  Copyright (c) 2008, Intel Corporation
#  All rights reserved. 
# 
#  This UEFI SCT ("Software") is furnished under license and may only be used or copied
#  in accordance with the terms of that license UEFI Contributor Agreement.
#  No license, express or implied, by estoppel or otherwise, to any intellectual property
#  rights is granted by this document. The Software is subject to change without notice,
#  and should not be construed as a commitment by Intel Corporation to market, license,
#  sell or support any product or technology. Unless otherwise provided for in the license
#  under which this Software is provided, the Software is provided AS IS, with no warranties
#  of any kind, express or implied. Except as expressly permitted by the Software license,
#  neither Intel Corporation nor its suppliers assumes any responsibility or liability
#  for any errors or inaccuracies that may appear herein.
#--*/
################################################################################
CaseLevel         CONFORMANCE
CaseAttribute     AUTO
CaseVerboseLevel  DEFAULT 
set reportfile    report.csv

#
# test case Name, category, description, GUID...
#
CaseGuid        3A377E18-7D09-4180-8017-51EB49668F9E
CaseName        DestroyChild.Conf2.Case1
CaseCategory    Udp4
CaseDescription {Test the EFI_UNSUPPORTED Conformance of UDP4.DestroyChild -   \
                 Invoke DestroyChild() to destroy an existed child twice.}
################################################################################

Include UDP4/include/Udp4.inc.tcl

#
# Begin log ...
#
BeginLog

#
# BeginScope
#
BeginScope  _UDP4_DESTROYCHILD_CONFORMANCE2_CASE1_

UINTN                            R_Status
UINTN                            R_Handle

#
# Create Child R_Handle
#
Udp4ServiceBinding->CreateChild "&@R_Handle, &@R_Status"
GetAck
set assert [VerifyReturnStatus R_Status $EFI_SUCCESS]
RecordAssertion $assert $GenericAssertionGuid                                  \
                "Udp4.DestroyChild - Func - Create Child"                      \
                "ReturnStatus - $R_Status, ExpectedStatus - $EFI_SUCCESS"

#
# Destroy Child R_Handle for the first time.
#
Udp4ServiceBinding->DestroyChild "@R_Handle, &@R_Status"
GetAck
set assert [VerifyReturnStatus R_Status $EFI_SUCCESS]
RecordAssertion $assert $GenericAssertionGuid                                  \
                "Udp4SB.DestroyChild - Func - Destroy Child"                   \
                "ReturnStatus - $R_Status,ExpectedStatus - $EFI_SUCCESS"

#
# Destroy Child R_Handle for the second time.
#
Udp4ServiceBinding->DestroyChild "@R_Handle, &@R_Status"
GetAck
set assert [VerifyReturnStatus R_Status $EFI_UNSUPPORTED]
RecordAssertion $assert $Udp4DestroyChildConf2AssertionGuid001                 \
                "Udp4SB.DestroyChild - Func - Destroy Child"                   \
                "ReturnStatus - $R_Status,ExpectedStatus - $EFI_UNSUPPORTED"
                
#
# End scope
#
EndScope _UDP4_DESTROYCHILD_CONFORMANCE2_CASE1_

#
# End log ...
#
EndLog
