/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:
  
    EmsInterface.h
    
Abstract:

    Data definition for interface related functions

--*/

#ifndef __EMS_INTERFACE_H__
#define __EMS_INTERFACE_H__

#include "EmsTypes.h"
#include "EmsTclInit.h"

extern
VOID_P
InterfaceTclInit (
  IN Tcl_Interp *Interp
  )
/*++

Routine Description:

  EMS Interface related TCL initialization.

Arguments:

  Interp      - TCL intepreter.

Returns:

  None

--*/
;

VOID
VifDownAll(
  VOID
  )
/*++

Routine Description:

  Shutdown all the virtual interface

Arguments:

  None

Returns:

  None

--*/
;

extern Tcl_CmdProc  TclVifUp;
extern Tcl_CmdProc  TclVifDown;
extern Tcl_CmdProc  TclGetMac;
extern Tcl_CmdProc  TclShowIf;
extern Tcl_CmdProc  TclSetIf;

#endif // __EMS_INTERFACE_H__
