#/*++
#  Copyright (c) 2008, Intel Corporation
#  All rights reserved. 
# 
#  This UEFI SCT ("Software") is furnished under license and may only be used or copied
#  in accordance with the terms of that license UEFI Contributor Agreement.
#  No license, express or implied, by estoppel or otherwise, to any intellectual property
#  rights is granted by this document. The Software is subject to change without notice,
#  and should not be construed as a commitment by Intel Corporation to market, license,
#  sell or support any product or technology. Unless otherwise provided for in the license
#  under which this Software is provided, the Software is provided AS IS, with no warranties
#  of any kind, express or implied. Except as expressly permitted by the Software license,
#  neither Intel Corporation nor its suppliers assumes any responsibility or liability
#  for any errors or inaccuracies that may appear herein.
#--*/
#/*++
#

# Module Name:
#
#   SctStartup.nsh
#
# Abstract:
#
#   Startup script for EFI SCT automatic running
#
#--*/

#
# NOTE: The file system name is hard coded since I don't know how to get the
# file system name in the script.
#

echo -off

for %i in 0 1 2 3 4 5 6 7 8 9 A B C D E F
  if exist FS%i:\Sct then
    #
    # Found EFI SCT harness
    #
    FS%i:
    cd Sct

    if %efishellmode%. == . then
      echo The EFI SCT cannot run in the old shell environment.
      goto Done
    endif

    echo Press any key to stop the EFI SCT running

    stallforkey.efi 10
    if %lasterror% == 0 then
      goto Done
    endif

    if exist FS%i:\Sct\.passive.mode then
      Sct -c -p mnp
    else
    Sct -c
    endif
    
#    load SCRT\SCRTDriver.efi
#    SCRT\SCRTApp.efi

    goto Done
  endif
endfor

:Done
