/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  InstallSct.h

Abstract:

  The EFI SCT installation.

--*/

#ifndef _EFI_INSTALL_SCT_H_
#define _EFI_INSTALL_SCT_H_

//
// Includes
//

#include "Efi.h"
#include "EfiShellLib.h"
#include "InstallSctDef.h"
#include "InstallSctSupport.h"

//
// Global definitions
//

#define INSTALL_SCT_1M                  (1024 * 1024)
#define INSTALL_SCT_FREE_SPACE          (1024 * 1024 * 100)

#define INSTALL_SCT_MAX_FILE_SYSTEM     0xFF
#define INSTALL_SCT_MAX_BACKUP          0xFF

#define INSTALL_SCT_STARTUP_FILE        L"SctStartup.nsh"

//
// Global variables
//

extern EFI_HANDLE gImageHandle;

//
// External functions
//

EFI_STATUS
InstallSct (
  IN EFI_HANDLE         ImageHandle,
  IN EFI_SYSTEM_TABLE   *SystemTable
  );

#endif
