/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  EfiTest.h

Abstract:

  EFI Test master include file. It produces the additional header file
  encapsule format for test.

--*/

#ifndef _EFI_TEST_H_
#define _EFI_TEST_H_

//
// Define macros for including test protocols
//

#define EFI_TEST_STRINGIZE(a)               #a
#define EFI_TEST_PROTOCOL_DEFINITION(a)     \
  EFI_TEST_STRINGIZE(Platform/IntelTest/Protocol/a/a.h)

//
// These should be used to include protocols.  If they are followed,
// intelligent build tools can be created to check dependencies at build
// time.
//
#define EFI_TEST_PROTOCOL_PRODUCER(a)       EFI_TEST_PROTOCOL_DEFINITION(a)
#define EFI_TEST_PROTOCOL_CONSUMER(a)       EFI_TEST_PROTOCOL_DEFINITION(a)

#endif
