/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  Perf.c

Abstract:

  Support for Performance primatives.

--*/

#include "Efi.h"
#include "EfiTestUtilitylib.h"
#include EFI_PROTOCOL_DEFINITION(Performance)

EFI_PERFORMANCE_PROTOCOL *Perf=NULL;
EFI_GUID gEfiPerformanceProtocolGuid2 = EFI_PERFORMANCE_PROTOCOL_GUID;


EFI_STATUS
StartMeasure (
  EFI_HANDLE         Handle,
  IN UINT16           *Token,
  IN UINT16           *Host,
  IN UINT64           Ticker
  )
{
  EFI_STATUS Status;
  if ( !Perf ) {
    Status = tBS->LocateProtocol ( &gEfiPerformanceProtocolGuid2,
                                  NULL,
                                  (VOID **)&Perf);
    if ( Status != EFI_SUCCESS ) {
      return Status;
    }
  }

  return (Perf -> StartGauge)( Perf, Handle, Token, Host, Ticker);
}


EFI_STATUS
EndMeasure (
  EFI_HANDLE         Handle,
  IN UINT16           *Token,
  IN UINT16           *Host,
  IN UINT64           Ticker
  )
{
  EFI_STATUS Status;
  if ( !Perf ) {
    Status = tBS->LocateProtocol ( &gEfiPerformanceProtocolGuid2,
                                  NULL,
                                  (VOID **)&Perf);
    if ( Status != EFI_SUCCESS ) {
      return Status;
    }
  }

  return (Perf->EndGauge)( Perf, Handle, Token, Host, Ticker) ;
}








