/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  EntsMonitorProtocol.h

Abstract:

--*/

#ifndef _ENTS_MONITOR_PROTOCOL_H_
#define _ENTS_MONITOR_PROTOCOL_H_

#include "Efi.h"

#define EFI_ENTS_MONITOR_PROTOCOL_GUID \
  { \
    0xf3f93305, 0x57e1, 0x43bf, 0x96, 0x20, 0xf1, 0x4a, 0xb3, 0x31, 0xe2, 0x7d \
  }

extern EFI_GUID gEfiEntsMonitorProtocolGuid;

EFI_FORWARD_DECLARATION (EFI_ENTS_MONITOR_PROTOCOL);

typedef
EFI_STATUS
(EFIAPI *EFI_INIT_MONITOR) (
  IN EFI_ENTS_MONITOR_PROTOCOL           * This
  );

typedef
EFI_STATUS
(EFIAPI *EFI_RESET_MONITOR) (
  IN EFI_ENTS_MONITOR_PROTOCOL           * This
  );

typedef
EFI_STATUS
(EFIAPI *EFI_MONITOR_LISTENER) (
  IN     EFI_ENTS_MONITOR_PROTOCOL       * This,
  IN OUT UINTN                           *Size,
  OUT CHAR16                             **Buffer
  );

typedef
EFI_STATUS
(EFIAPI *EFI_MONITOR_SENDER) (
  IN EFI_ENTS_MONITOR_PROTOCOL           * This,
  IN CHAR16                              *Buffer
  );

typedef
EFI_STATUS
(EFIAPI *EFI_MONITOR_VALIDATER) (
  IN EFI_ENTS_MONITOR_PROTOCOL           * This
  );

typedef
EFI_STATUS
(EFIAPI *EFI_MONITOR_SAVECONTEXT) (
  IN EFI_ENTS_MONITOR_PROTOCOL                 *This
  );

typedef
EFI_STATUS
(EFIAPI *EFI_MONITOR_RESTORECONTEXT) (
  IN EFI_ENTS_MONITOR_PROTOCOL                 *This
  );

typedef struct _EFI_ENTS_MONITOR_PROTOCOL {
  VOID                        *MonitorName;
  VOID                        *MonitorIo;
  EFI_INIT_MONITOR            InitMonitor;
  EFI_RESET_MONITOR           ResetMonitor;
  BOOLEAN                     CleanUpEnvironmentFlag;
  EFI_MONITOR_LISTENER        MonitorListener;
  EFI_MONITOR_SENDER          MonitorSender;
  EFI_MONITOR_SAVECONTEXT     MonitorSaveContext;
  EFI_MONITOR_RESTORECONTEXT  MonitorRestoreContext;
} EFI_ENTS_MONITOR_PROTOCOL;

#endif // _ENTS_MONITOR_PROTOCOL_H_
