/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  AcpiTableBBTestMain.h

Abstract:

  Test Driver of Acpi Table Protocol header file

--*/

#ifndef _ACPI_TABLE_PROTOCOL_BB_TEST_MAIN_H
#define _ACPI_TABLE_PROTOCOL_BB_TEST_MAIN_H


#include "Efi.h"
#include "EfiTest.h"
#include "EfiTestLib.h"
#include "AcpiTableProtocol.h"
#include "EfiTestUtilityLib.h"
#include "EfiCommonLib.h"
#include "Guid.h"



#define EFI_ACPI_TABLE_PROTOCOL_TEST_REVISION    0x00010000

//
// Entry GUIDs for Func Test
//

//
// Entry GUIDs for Conf Test
//
#define EFI_ACPI_TABLE_PROTOCOL_TEST_ENTRY_GUID0201 \
{0x9689be8f, 0x13e4, 0x4705, { 0xbd, 0xb8, 0xe1, 0x92, 0x94, 0x3b, 0xbf, 0x92 } }

#define EFI_ACPI_TABLE_PROTOCOL_TEST_ENTRY_GUID0202 \
{0x67a7dbd, 0xdb96, 0x426b, { 0x9f, 0x16, 0xed, 0xdf, 0x0, 0xa3, 0xb4, 0x75 } }

#define EFI_ACPI_TABLE_PROTOCOL_TEST_ENTRY_GUID0101 \
{0x9c0b1a63, 0x33b8, 0x4a79, { 0xa8, 0xf6, 0x73, 0x4f, 0xaf, 0xe4, 0x25, 0x33 } }


#define EFI_ACPI_TABLE_PROTOCOL_TEST_ENTRY_GUID0102 \
{0x10f71445, 0xeba2, 0x4421, { 0x8d, 0xf2, 0x90, 0xc4, 0x2f, 0x6d, 0xc8, 0x23 } }


EFI_STATUS
InitializeBBTestAcpiTableProtocol (
  IN EFI_HANDLE                   ImageHandle,
  IN EFI_SYSTEM_TABLE             *SystemTable
  );
  
EFI_STATUS
UnloadBBTestAcpiTableProtocol (
  IN EFI_HANDLE                   ImageHandle
  );

//
// Prototypes: Test Cases
//

EFI_STATUS
BBTestInstallAcpiTableConformanceTest (
  IN EFI_BB_TEST_PROTOCOL       *This,
  IN VOID                       *ClientInterface,
  IN EFI_TEST_LEVEL             TestLevel,
  IN EFI_HANDLE                 SupportHandle
  );
  
  
EFI_STATUS
BBTestUninstallAcpiTableConformanceTest (
  IN EFI_BB_TEST_PROTOCOL       *This,
  IN VOID                       *ClientInterface,
  IN EFI_TEST_LEVEL             TestLevel,
  IN EFI_HANDLE                 SupportHandle
  ); 
  
  
EFI_STATUS
BBTestInstallAcpiTableFunctionTest (
  IN EFI_BB_TEST_PROTOCOL       *This,
  IN VOID                       *ClientInterface,
  IN EFI_TEST_LEVEL             TestLevel,
  IN EFI_HANDLE                 SupportHandle
  );
  
  
EFI_STATUS
BBTestUninstallAcpiTableFunctionTest (
  IN EFI_BB_TEST_PROTOCOL       *This,
  IN VOID                       *ClientInterface,
  IN EFI_TEST_LEVEL             TestLevel,
  IN EFI_HANDLE                 SupportHandle
  ); 

  
EFI_STATUS
BBTestInstallAcpiTableConformanceTestCheckpoint1 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL    *StandardLib,
  IN EFI_ACPI_TABLE_PROTOCOL          *AcpiTable
  );
  

EFI_STATUS
BBTestInstallAcpiTableConformanceTestCheckpoint2 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL    *StandardLib,
  IN EFI_ACPI_TABLE_PROTOCOL          *AcpiTable
  );


EFI_STATUS
BBTestInstallAcpiTableConformanceTestCheckpoint3 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL    *StandardLib,
  IN EFI_ACPI_TABLE_PROTOCOL          *AcpiTable
  );


EFI_STATUS
BBTestUninstallAcpiTableConformanceTestCheckpoint1 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL    *StandardLib,
  IN EFI_ACPI_TABLE_PROTOCOL          *AcpiTable
  );
  
  
EFI_STATUS
BBTestInstallAcpiTableFunctionTestCheckpoint1 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL    *StandardLib,
  IN EFI_ACPI_TABLE_PROTOCOL          *AcpiTable
  );
  
  
EFI_STATUS
BBTestUninstallAcpiTableFunctionTestCheckpoint1 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL    *StandardLib,
  IN EFI_ACPI_TABLE_PROTOCOL          *AcpiTable
  );
  
  
#endif