/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  DecompressProtocol.h

Abstract:

  The Decompress Protocol Interface (Just for Test)

--*/

#ifndef _DECOMPRESS_TEST_H_
#define _DECOMPRESS_TEST_H_

#define EFI_DECOMPRESS_PROTOCOL_GUID  \
  { 0xd8117cfe, 0x94a6, 0x11d4, 0x9a, 0x3a, 0x0, 0x90, 0x27, 0x3f, 0xc1, 0x4d }

EFI_FORWARD_DECLARATION(EFI_DECOMPRESS_PROTOCOL);

typedef
EFI_STATUS
(EFIAPI *EFI_DECOMPRESS_GET_INFO) (
  IN   EFI_DECOMPRESS_PROTOCOL  *This,
  IN   VOID                     *Source,
  IN   UINT32                   SourceSize,
  OUT  UINT32                   *DestinationSize,
  OUT  UINT32                   *ScratchSize
  );

typedef
EFI_STATUS
(EFIAPI *EFI_DECOMPRESS_DECOMPRESS) (
  IN     EFI_DECOMPRESS_PROTOCOL  *This,
  IN     VOID*                    Source,
  IN     UINT32                   SourceSize,
  IN OUT VOID*                    Destination,
  IN     UINT32                   DestinationSize,
  IN OUT VOID*                    Scratch,
  IN     UINT32                   ScratchSize
  );

typedef struct _EFI_DECOMPRESS_PROTOCOL {
  EFI_DECOMPRESS_GET_INFO    GetInfo;
  EFI_DECOMPRESS_DECOMPRESS  Decompress;
} EFI_DECOMPRESS_PROTOCOL;

extern EFI_GUID gEfiDecompressProtocolGuid;

#endif
