/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  Application2.c

Abstract:

  for Loaded Image Protocol Black Box Test

--*/

#include "LoadedImageBBTestProtocolDefinition.h"
#include "EfiTestLib.h"

//
// data definition here
//

EFI_STATUS
InitializeEfiApplication2 (
  IN EFI_HANDLE           ImageHandle,
  IN EFI_SYSTEM_TABLE     *SystemTable
  );

EFI_DRIVER_ENTRY_POINT(InitializeEfiApplication2)

EFI_STATUS
InitializeEfiApplication2 (
  IN EFI_HANDLE           ImageHandle,
  IN EFI_SYSTEM_TABLE     *SystemTable
  )
{
  EFI_STATUS              Status;
  EFI_HANDLE              Handle;
  UINTN                   *Options;

  EFI_LOADED_IMAGE_PROTOCOL   *LoadedImage;

  Handle = NULL;

  EfiInitializeTestLib (ImageHandle, SystemTable);

  Status = gtBS->HandleProtocol (
                   ImageHandle,
                   &gEfiLoadedImageProtocolGuid,
                   &LoadedImage
                   );
  if (EFI_ERROR (Status)) {
    return Status;
  }

  Options = (UINTN*)(LoadedImage->LoadOptions);

  if (Options == NULL) {
    return EFI_SUCCESS;
  }

  if (*Options == 1) {

    gtBS->InstallProtocolInterface (
            &Handle,
            &mLoadedImageTestNoInterfaceProtocol1Guid,
            EFI_NATIVE_INTERFACE,
            NULL
            );
  } else if (*Options == 2) {
    gtBS->InstallProtocolInterface (
            &Handle,
            &mLoadedImageTestNoInterfaceProtocol2Guid,
            EFI_NATIVE_INTERFACE,
            NULL
            );
  }


  gtBS->UninstallProtocolInterface (
          Handle,
          &mLoadedImageTestNoInterfaceProtocol1Guid,
          NULL
          );
  gtBS->UninstallProtocolInterface (
          Handle,
          &mLoadedImageTestNoInterfaceProtocol2Guid,
          NULL
          );
  return EFI_SUCCESS;
}

