/*++
 Copyright (c) 2008, Intel Corporation
 All rights reserved. 

 This UEFI SCT ("Software") is furnished under license and may only be used or copied
 in accordance with the terms of that license UEFI Contributor Agreement.
 No license, express or implied, by estoppel or otherwise, to any intellectual property
 rights is granted by this document. The Software is subject to change without notice,
 and should not be construed as a commitment by Intel Corporation to market, license,
 sell or support any product or technology. Unless otherwise provided for in the license
 under which this Software is provided, the Software is provided AS IS, with no warranties
 of any kind, express or implied. Except as expressly permitted by the Software license,
 neither Intel Corporation nor its suppliers assumes any responsibility or liability
 for any errors or inaccuracies that may appear herein.
--*/
/*++

Module Name:

  TestNodeMenu.h

Abstract:

  Deal with the user interface menu for test nodes.

--*/

#ifndef _EFI_TEST_NODE_MENU_H_
#define _EFI_TEST_NODE_MENU_H_

//
//  Includes
//

#include "Sct.h"
#include "Ui.h"
#include "BuildMenu.h"
#include "Dialog.h"
#include EFI_PROTOCOL_DEFINITION(DevicePath)

//
// Definitions
//

#define ITERATION_NUMBER_MAX     999
#define ITERATION_NUMBER_MIN     0
#define ITERATION_NUMBER_DEFAULT 0

//
// Functions
//

EFI_STATUS
DisplayTestNodeMenu (
  IN EFI_LIST_ENTRY               *Root,
  IN EFI_MENU_PAGE                *ParentPage
  );

UINTN
CalculatePassNumber (
  EFI_SCT_TEST_NODE               *TestNode
  );

UINTN
CalculateTotalPassNumber (
  EFI_LIST_ENTRY                  *Root
  );

UINTN
CalculateFailNumber (
  EFI_SCT_TEST_NODE               *TestNode
  );

UINTN
CalculateTotalFailNumber (
  EFI_LIST_ENTRY                  *Root
  );

UINT32
GetTestCaseIterations (
  IN EFI_GUID                     *Guid
  );

#endif
